function[P, F] = LG(P, F, initial_P, initial_F, i, alpha, beta, M1, M2, M3, maxiter)

% disp(['Running with ' int2str(i) 'th node in Network A']);

a = ((1 - alpha)/(2 - alpha));
b = ((1 - beta)/(2 - beta));

tmp_F = a*M3*(F);

for iter = 1:maxiter
    if(mod(iter,50)==0)
        iter
    end

    old_P = P;
    P = a*M1*old_P + ((1-2*a)*initial_P + (tmp_F));

    if ((max(max(abs(P - old_P)))) <1e-9)
        break
    end
end

% disp('running iteration until convergence in Network B)')

tmp_P = b*M3'*(P);

for iter = 1:maxiter
    if(mod(iter,50)==0)
        iter
    end

    old_F = F;
    F = b*M2*old_F + ((1-2*b)*initial_F + (tmp_P));

    if ((max(max(abs(F - old_F)))) <1e-9)
        break
    end
end

