%% To run MINProp, we assume that you have the following data
% 1) Network_A: Network_A is normalized (both row and column) network data (n by n)
% 2) Network_B: Network_B is normalized (both row and column) network data (m by m)
% 3) Network_AB: Network_AB is normaized bipartite graph (both row and column) data (n by m)
% 4) query node idx: your query node index

[nh d] = size(Network_A);
[nn d] = size(Network_A);

%parameter
alpha = [0.1 0.3 0.5 0.7 0.9]; % parameter for network A
beta =  [0.1 0.3 0.5 0.7 0.9]; % parameter for network B

% initialize query vector
P = zeros(nh,1); 
F = zeros(nm,1);

% assign initial label information to query node, other nodes are
% set  to zero
P(query_node_idx) = 1;
initial_P = P;
initial_F = F;

%maxiter for label propagation
maxiter = 1000;
maxiter2 = 1000;


for j = 1:length(alpha) 
    for k = 1:length(beta)
        for iter = 1:maxiter2
            [final_P_LGM, final_F_LGM] = LG(P, F, initial_P, initial_F, query_node_idx, alpha(j), beta(k), Network_A, Network_B, Network_AB, maxiter);
            old_P = final_P_LGM;
            old_F = final_F_LGM;

            if (((max(max(abs(P - old_P)))) <1e-9) && ((max(max(abs(F - old_F)))) <1e-9))   
                break
            end

            [final_P_LGM, final_F_LGM] = LG(old_P, old_F, initial_P, initial_F, query_node_idx, alpha(j), beta(k), Network_A, Network_B, Network_AB, maxiter);
            P = final_P_LGM;
            F = final_F_LGM;

            if (((max(max(abs(P - old_P)))) <1e-9) && ((max(max(abs(F - old_F)))) <1e-9))                                     
                break
            end
        end
    end
end
